
_HC595_reset:

;7_Seg.c,46 :: 		void HC595_reset()
;7_Seg.c,48 :: 		HC595_RES = 0;
	LDS        R27, HC595_RES+0
	CBR        R27, BitMask(HC595_RES+0)
	STS        HC595_RES+0, R27
;7_Seg.c,49 :: 		Delay_ms(5);
	LDI        R17, 52
	LDI        R16, 242
L_HC595_reset0:
	DEC        R16
	BRNE       L_HC595_reset0
	DEC        R17
	BRNE       L_HC595_reset0
	NOP
;7_Seg.c,50 :: 		HC595_RES = 1;
	LDS        R27, HC595_RES+0
	SBR        R27, BitMask(HC595_RES+0)
	STS        HC595_RES+0, R27
;7_Seg.c,51 :: 		}
L_end_HC595_reset:
	RET
; end of _HC595_reset

_HC595_load:

;7_Seg.c,53 :: 		void HC595_load()
;7_Seg.c,55 :: 		HC595_LAT = 0;
	LDS        R27, HC595_LAT+0
	CBR        R27, BitMask(HC595_LAT+0)
	STS        HC595_LAT+0, R27
;7_Seg.c,56 :: 		Delay_ms(5);
	LDI        R17, 52
	LDI        R16, 242
L_HC595_load2:
	DEC        R16
	BRNE       L_HC595_load2
	DEC        R17
	BRNE       L_HC595_load2
	NOP
;7_Seg.c,57 :: 		HC595_LAT = 1;
	LDS        R27, HC595_LAT+0
	SBR        R27, BitMask(HC595_LAT+0)
	STS        HC595_LAT+0, R27
;7_Seg.c,58 :: 		}
L_end_HC595_load:
	RET
; end of _HC595_load

_seg_7_display:

;7_Seg.c,73 :: 		int8_t seg_7_display(char c)
;7_Seg.c,79 :: 		if (c < MIN_ASCII_DEC || c > MAX_ASCII_DEC)
	PUSH       R2
	LDI        R27, 48
	CP         R2, R27
	BRSH       L__seg_7_display17
	JMP        L__seg_7_display13
L__seg_7_display17:
	LDI        R16, 122
	CP         R16, R2
	BRSH       L__seg_7_display18
	JMP        L__seg_7_display12
L__seg_7_display18:
	JMP        L_seg_7_display6
L__seg_7_display13:
L__seg_7_display12:
;7_Seg.c,80 :: 		return -1;
	LDI        R16, 255
	JMP        L_end_seg_7_display
L_seg_7_display6:
;7_Seg.c,82 :: 		index = c - ASCII_OFFSET;
	MOV        R18, R2
	SUBI       R18, 48
;7_Seg.c,83 :: 		seg = dig_array[index];
	LDI        R16, #lo_addr(_dig_array+0)
	LDI        R17, hi_addr(_dig_array+0)
	MOV        R30, R18
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	LD         R16, Z
; seg start address is: 17 (R17)
	MOV        R17, R16
;7_Seg.c,85 :: 		if (seg == 0)
	CPI        R16, 0
	BREQ       L__seg_7_display19
	JMP        L_seg_7_display7
L__seg_7_display19:
; seg end address is: 17 (R17)
;7_Seg.c,86 :: 		return -1;
	LDI        R16, 255
	JMP        L_end_seg_7_display
L_seg_7_display7:
;7_Seg.c,88 :: 		else seg7_send_byte(seg);
; seg start address is: 17 (R17)
	MOV        R2, R17
; seg end address is: 17 (R17)
	CALL       _seg7_send_byte+0
;7_Seg.c,90 :: 		return 0;
	LDI        R16, 0
;7_Seg.c,91 :: 		}
;7_Seg.c,90 :: 		return 0;
;7_Seg.c,91 :: 		}
L_end_seg_7_display:
	POP        R2
	RET
; end of _seg_7_display

_seg7_send_byte:

;7_Seg.c,93 :: 		void seg7_send_byte (uint8_t sendbyte)
;7_Seg.c,95 :: 		SPI_Write(sendbyte);
	CALL       _SPI_Write+0
;7_Seg.c,96 :: 		Delay_ms(1);
	LDI        R17, 11
	LDI        R16, 99
L_seg7_send_byte9:
	DEC        R16
	BRNE       L_seg7_send_byte9
	DEC        R17
	BRNE       L_seg7_send_byte9
;7_Seg.c,97 :: 		HC595_load();
	CALL       _HC595_load+0
;7_Seg.c,98 :: 		}
L_end_seg7_send_byte:
	RET
; end of _seg7_send_byte

7_Seg____?ag:

L_end_7_Seg___?ag:
	RET
; end of 7_Seg____?ag
