
_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;Big7SEGAVR.c,70 :: 		void main()
;Big7SEGAVR.c,73 :: 		HC595_PWM_Direction = 1;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	PUSH       R8
	IN         R27, DDD4_bit+0
	SBR        R27, BitMask(DDD4_bit+0)
	OUT        DDD4_bit+0, R27
;Big7SEGAVR.c,74 :: 		HC595_RES_Direction = 1;
	IN         R27, DDA6_bit+0
	SBR        R27, BitMask(DDA6_bit+0)
	OUT        DDA6_bit+0, R27
;Big7SEGAVR.c,75 :: 		HC595_LAT_Direction = 1;
	IN         R27, DDA5_bit+0
	SBR        R27, BitMask(DDA5_bit+0)
	OUT        DDA5_bit+0, R27
;Big7SEGAVR.c,78 :: 		SPI1_Init_Advanced( _SPI_MASTER, _SPI_FCY_DIV32, _SPI_CLK_LO_LEADING);
	CLR        R4
	LDI        R27, 6
	MOV        R3, R27
	LDI        R27, 16
	MOV        R2, R27
	CALL       _SPI1_Init_Advanced+0
;Big7SEGAVR.c,79 :: 		SPI_Set_Active(SPI1_Read, SPI1_Write); // Sets the SPI1 module active
	LDI        R27, #lo_addr(_SPI1_Write+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_SPI1_Write+0)
	MOV        R5, R27
	LDI        R27, #lo_addr(_SPI1_Read+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_SPI1_Read+0)
	MOV        R3, R27
	CALL       _SPI_Set_Active+0
;Big7SEGAVR.c,82 :: 		pwm_period = 256;
	LDI        R27, 0
	STS        _pwm_period+0, R27
	LDI        R27, 1
	STS        _pwm_period+1, R27
;Big7SEGAVR.c,85 :: 		_PWM16_NON_INVERTED, 255, 1);
	LDI        R27, 1
	MOV        R7, R27
	LDI        R27, 0
	MOV        R8, R27
	LDI        R27, 255
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	LDI        R27, 160
	MOV        R4, R27
;Big7SEGAVR.c,84 :: 		_PWM16_PRESCALER_16bit_8,
	LDI        R27, 2
	MOV        R3, R27
;Big7SEGAVR.c,83 :: 		PWM16bit_Init(_PWM16_PHASE_CORRECT_MODE_8BIT,
	LDI        R27, 11
	MOV        R2, R27
;Big7SEGAVR.c,85 :: 		_PWM16_NON_INVERTED, 255, 1);
	CALL       _PWM16bit_Init+0
;Big7SEGAVR.c,86 :: 		PWM16bit_Start(_TIMER1);
	LDI        R27, 1
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _PWM16bit_Start+0
;Big7SEGAVR.c,87 :: 		PWM16bit_Change_Duty(190, _TIMER1_CH_B);
	LDI        R27, 18
	MOV        R4, R27
	LDI        R27, 190
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _PWM16bit_Change_Duty+0
;Big7SEGAVR.c,90 :: 		HC595_LAT = 0;
	IN         R27, PORTA5_bit+0
	CBR        R27, BitMask(PORTA5_bit+0)
	OUT        PORTA5_bit+0, R27
;Big7SEGAVR.c,91 :: 		HC595_reset();
	CALL       _HC595_reset+0
;Big7SEGAVR.c,94 :: 		counter = 0;
	LDI        R27, 0
	STS        _counter+0, R27
;Big7SEGAVR.c,95 :: 		luminosity = 0;
	LDI        R27, 0
	STS        _luminosity+0, R27
	STS        _luminosity+1, R27
;Big7SEGAVR.c,98 :: 		while (1)
L_main0:
;Big7SEGAVR.c,100 :: 		valid = seg_7_display(demo_array[counter]);
	LDI        R17, #lo_addr(_demo_array+0)
	LDI        R18, hi_addr(_demo_array+0)
	LDS        R16, _counter+0
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R17
	ADC        R31, R18
	LD         R16, Z
	MOV        R2, R16
	CALL       _seg_7_display+0
	STS        _valid+0, R16
;Big7SEGAVR.c,101 :: 		PWM16bit_Change_Duty(190 - luminosity, _TIMER1_CH_B);
	LDS        R0, _luminosity+0
	LDS        R1, _luminosity+1
	LDI        R16, 190
	LDI        R17, 0
	SUB        R16, R0
	SBC        R17, R1
	LDI        R27, 18
	MOV        R4, R27
	MOVW       R2, R16
	CALL       _PWM16bit_Change_Duty+0
;Big7SEGAVR.c,102 :: 		Delay_ms(750);
	LDI        R18, 31
	LDI        R17, 113
	LDI        R16, 31
L_main2:
	DEC        R16
	BRNE       L_main2
	DEC        R17
	BRNE       L_main2
	DEC        R18
	BRNE       L_main2
	NOP
;Big7SEGAVR.c,103 :: 		luminosity += 5;
	LDS        R16, _luminosity+0
	LDS        R17, _luminosity+1
	SUBI       R16, 251
	SBCI       R17, 255
	STS        _luminosity+0, R16
	STS        _luminosity+1, R17
;Big7SEGAVR.c,104 :: 		counter++;
	LDS        R16, _counter+0
	SUBI       R16, 255
	STS        _counter+0, R16
;Big7SEGAVR.c,105 :: 		if (counter == 20)
	CPI        R16, 20
	BREQ       L__main7
	JMP        L_main4
L__main7:
;Big7SEGAVR.c,106 :: 		counter = 0;
	LDI        R27, 0
	STS        _counter+0, R27
L_main4:
;Big7SEGAVR.c,107 :: 		if (luminosity == 180)
	LDS        R16, _luminosity+0
	LDS        R17, _luminosity+1
	CPI        R17, 0
	BRNE       L__main8
	CPI        R16, 180
L__main8:
	BREQ       L__main9
	JMP        L_main5
L__main9:
;Big7SEGAVR.c,108 :: 		luminosity = 0;
	LDI        R27, 0
	STS        _luminosity+0, R27
	STS        _luminosity+1, R27
L_main5:
;Big7SEGAVR.c,109 :: 		}
	JMP        L_main0
;Big7SEGAVR.c,110 :: 		}
L_end_main:
	POP        R8
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
