#line 1 "D:/Stefan Popovic/Projekti/Click_Big_7_Seg_R_74HC595/example/AVR/Big7SEGAVR.c"
#line 1 "d:/stefan popovic/projekti/click_big_7_seg_r_74hc595/example/avr/7_seg.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 50 "d:/stefan popovic/projekti/click_big_7_seg_r_74hc595/example/avr/7_seg.h"
 void HC595_reset( void );
 void HC595_load( void );


 int8_t seg_7_display( char c );


 void seg7_send_byte ( uint8_t byte );
#line 44 "D:/Stefan Popovic/Projekti/Click_Big_7_Seg_R_74HC595/example/AVR/Big7SEGAVR.c"
 sbit HC595_RES at PORTA6_bit;
 sbit HC595_LAT at PORTA5_bit;
 sbit HC595_PWM at PORTD4_bit;

 sbit HC595_RES_Direction at DDA6_bit;
 sbit HC595_LAT_Direction at DDA5_bit;
 sbit HC595_PWM_Direction at DDD4_bit;
#line 56 "D:/Stefan Popovic/Projekti/Click_Big_7_Seg_R_74HC595/example/AVR/Big7SEGAVR.c"
 extern char dig_array[ 75 ];


 unsigned short counter;
 unsigned int luminosity;
 unsigned int pwm_period;
 int8_t valid;

 char demo_array[20] =
 { 'M', 'I', 'K', 'R', 'O',
 'E', 'L', 'E', 'K', 'T', 'R', 'O', 'N', 'I', 'K', 'A',
 '2', '0', '1', '6'
 };

 void main()
 {

 HC595_PWM_Direction = 1;
 HC595_RES_Direction = 1;
 HC595_LAT_Direction = 1;


 SPI1_Init_Advanced( _SPI_MASTER, _SPI_FCY_DIV32, _SPI_CLK_LO_LEADING);
 SPI_Set_Active(SPI1_Read, SPI1_Write);


 pwm_period = 256;
 PWM16bit_Init(_PWM16_PHASE_CORRECT_MODE_8BIT,
 _PWM16_PRESCALER_16bit_8,
 _PWM16_NON_INVERTED, 255, 1);
 PWM16bit_Start(_TIMER1);
 PWM16bit_Change_Duty(190, _TIMER1_CH_B);


 HC595_LAT = 0;
 HC595_reset();


 counter = 0;
 luminosity = 0;


 while (1)
 {
 valid = seg_7_display(demo_array[counter]);
 PWM16bit_Change_Duty(190 - luminosity, _TIMER1_CH_B);
 Delay_ms(750);
 luminosity += 5;
 counter++;
 if (counter == 20)
 counter = 0;
 if (luminosity == 180)
 luminosity = 0;
 }
 }
